(*

let fibs = let rec next x y = x :: next y (x+y) in next 1 1

This implementation doesn't work, since it leads to
an infinite computation.

Hence the module [Lazy] from the standard library is used
to defer computation until it is forced.
*)

(* A datatype for infinite lists. Note the mutual recursive
dependencies between [cell] and [inflist]. *)
type 'a cell   = Cons of 'a * 'a inflist
and 'a inflist = 'a cell Lazy.t

(* [take n xs] takes the first [n] elements from the infinite list
[xs] and returns them as a [list]. *)
let rec take n xs = if n < 1 then [] else (
 match Lazy.force xs with Cons(x,xs) -> x :: take (n-1) xs
)

(* [fibs] is the infinite sequence of Fibonacci numbers. *)
let fibs = let rec next x y = lazy(Cons(x,next y (x + y))) in next 1 1
